

//	(C) 2017 R-MIK Sawomir Skrzyski
//	slawomir.skrzynski@ep.com.pl


#ifndef ANSI_H_
#define	ANSI_H_


//=======================================================================//
#define CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'

#define	SOH		'\001'		// 01H			Start of Heading
#define	EOT		'\004'		// 04H			End of Transmission
#define	FFs		"\014"		// 12 ASCII		Form Feed
#define	ESC		'\033'		// 1BH			Escape
#define	XON		'\021'		// 17 ASCII
#define	XOFF	'\023'		// 19 ASCII
#define	ACK		'\006'		// 06H			Acknowledgement
#define	NAK		'\025'		// 15H			Negative Acknowledgement
#define	CAN		'\030'		// 18H			Cancel

#define	ANSI				"\x1B["		// ESC + "["
#define	SGR					ANSI_
#define	CSI					ANSI_
#define	SGR_				ANSI_
#define	CSI_				ANSI_

// Kody CSI
#define	ANSI_CUU			ANSI"A"		// Kursor gra
#define	ANSI_CUD			ANSI"B"		// d
#define	ANSI_CUF			ANSI"C"		// prawo
#define	ANSI_CUB			ANSI"D"		// lewo
#define	ANSI_HOME			ANSI"H"
#define	ANSI_CLS			ANSI"J"
// Kody SGR
#define	ANSI_OFF			ANSI"0m"
#define	ANSI_BOLD			ANSI"1m"
#define	ANSI_UNDERSCORE		ANSI"4m"	//Underscore
#define	ANSI_BLINK			ANSI"5m"	// Blink
#define	ANSI_NEG			ANSI"7m"	// Negative (reverse) image

enum{ANSI_BLACK, ANSI_RED, ANSI_GREEN, ANSI_YELLOW, ANSI_BLUE, ANSI_MAGNETA, ANSI_CYAN, ANSI_WHITE };
#define	ANSI_PEN_BLACK		ANSI"30m"
#define	ANSI_PEN_RED		ANSI"31m"
#define	ANSI_PEN_GREEN		ANSI"32m"
#define	ANSI_PEN_YELLOW		ANSI"33m"
#define	ANSI_PEN_BLUE		ANSI"34m"
#define	ANSI_PEN_MAGNETA	ANSI"35m"
#define	ANSI_PEN_CYAN		ANSI"36m"
#define	ANSI_PEN_WHITE		ANSI"37m"
#define	ANSI_BACK_BLACK		ANSI"40m"
#define	ANSI_BACK_RED		ANSI"41m"
#define	ANSI_BACK_GREEN		ANSI"42m"
#define	ANSI_BACK_YELLOW	ANSI"43m"
#define	ANSI_BACK_BLUE		ANSI"44m"
#define	ANSI_BACK_MAGNETA	ANSI"45m"
#define	ANSI_BACK_CYAN		ANSI"46m"
#define	ANSI_BACK_WHITE		ANSI"47m"


//=======================================================================//
#endif
