


//======================================================================//


#define	DS2480_WAIT_BYTE_MS		6


#define	DS2480_CMD	1
#define	DS2480_DATA	0


#define	DS2480_9600		0
#define	DS2480_19200	0b010
#define	DS2480_57600	0b100
#define	DS2480_115200	0b110

#define	MODSEL_DATA		1
#define	MODSEL_COMMAND	0

#define	READ_FUNCTION	1
#define	WRITE_FUNCTION	2


//======================================================================//
extern byte DS2480_Init();
extern byte DS2480_Version();
void DS2480_break();
word DS2480_Get();
byte DS2480_GetBlockDS( byte *buf, byte len, word timeout );
void DS2480_PGMpulse( byte vpp );
extern void DS2480_OverdriveOnOff( byte ovd );
byte DS2480_RBR( byte predkosc );
void DS2480_Put( byte dana );
byte DS2480loopBack;
byte UMode;
byte DS2480_Mode;
byte DS24820status=-1;


byte DS2480_rst=-1;
// 0b00 1-Wire shorted
// 0b01 presence
// 0b10 alarm presence
// 0b11 no presence
byte DS2480_vpp;
// 0x1xxxx - Vpp
byte DS2480_ver;
// 010xx DS2480
// 011xx DS2480B
// 100xx (future)
byte DS2480_rbr;
// 0b000 9600
// 0b010 19200
// 0b100 57600
// 0b110 115200

extern void DS2480_cmd( byte cmd );
extern byte DS2480_OW_Reset();
extern byte DS2480_TestVpp();
extern word DS2480_OW_RDbit();
extern word DS2480_OW_WRbit( byte bit );
extern word DS2480_OW_WRbyte( byte bajt );
byte DS2480_OW_LastByte;
extern word DS2480_OW_RDbyte();
byte DS2480LastDiscrepancy, DS2480LastDevice, DS2480LastFamilyDiscrepancy;
extern byte DS2480_OWFirst( byte alarm_only );
extern byte DS2480_OWNext( byte alarm_only );
extern byte DS2480_OWSearch( byte alarm_only );
byte bitacc( byte op, byte state, byte loc, byte *buf );


#ifndef OW_SEARCH_ROM_NO
extern  unsigned char OW_SEARCH_ROM_NO[8];
#else
  #error "stala?"
#endif


//======================================================================//
void DS2480_Put( byte dana )
{
	PutDS( dana );
	if ( !onewireOverdrive && DS2480_rbr ) _delay_us( 1200 );	// Przy transmisji danych (bajtowo) wystarcza 700us, ale search rom potrzebuje wicej czasu (prawie 1ms)
}


//----------------------------------------------------------------------//
word DS2480_Get()
{
word timeout100us = 10 * DS2480_WAIT_BYTE_MS;
word dana;


	if ( onewireOverdrive ) timeout100us /= 10;


	while ( timeout100us-- )
		{
		if ( (dana=GetDS()) != NONE )
			{
			if ( DS2480_Mode == DS2480_CMD )
			DS24820status = dana;	// Jeli tryb CMD to zapamitaj odpowied
			return( dana );
			}
		_delay_us(100);
		}


	return( NONE );
}


//----------------------------------------------------------------------//
// timeout w ms (9600 - 1znak 1ms)
//
//todo: w owerdrine * 1
byte DS2480_GetBlockDS( byte *buf, byte len, word timeout )
{
byte cnt=0;
word dana;


	timeout *= 10;

	while ( timeout-- )
		{
		if ( (dana=GetDS()) != NONE )
		 	{
			*buf++ = dana;
			if ( ++cnt == len ) break;
			}
		_delay_us(100);
		}

#warning "USER: wdrozyc bo nie dziala"
/*
	while( len != cnt )
		{
		*buf = DS2480_Get();
		buf++;
		cnt++;
		}
*/


	return( cnt );
}


//======================================================================//
// Ponisze zadzaa jeli bdzie wydane zaraz po komendzie przejcia w overdrive
// co wydaje si by spraw oczywist
//
void DS2480_OverdriveOnOff( byte ovd )
{
byte cfg=0, last;



	// Zapobieganie petli lokalnej w overdrive dla Emulatora 1-Wire
	if ( DS2480loopBack )
	  	{
		if ( DS2480_OW_LastByte == ONEWIRE_OVD_SKIPROM ) DS2480_OW_LastByte = ONEWIRE_CMD_SKIPROM;
		if ( DS2480_OW_LastByte == ONEWIRE_OVD_MATCHROM ) DS2480_OW_LastByte = ONEWIRE_CMD_MATCHROM;
		DS2480_OW_Reset();
		DS2480_OW_WRbyte( DS2480_OW_LastByte );
		return;		// Wyjcie bez zmiany prdkoci
		}


	if( ovd )
		{
		last = DS2480_OW_LastByte;
		// Komenda jeszcze w standardowej prdkoci
		DS2480_OW_Reset();
		DS2480_OW_WRbyte( ONEWIRE_OVD_SKIPROM );
		// Wczenie overdrive
		onewireOverdrive = true;
		// Reset w overdrive
		DS2480_OW_Reset();
		DS2480_OW_WRbyte( last );
		}


	onewireOverdrive = ovd;
}


//----------------------------------------------------------------------//
#if	USARTDS_BITS != 8 || USARTDS_PARITY != 'n' || USARTDS_STOP != 1
  #error "Zle parametry transmisji"
#endif

#if defined( USARTDS_IRQRX	) && USARTDS_RXBUF < 17
  #error "Wymagany bufor odbiorczy conajmniej 17 bajtow"
#endif


//======================================================================//
byte DS2480_OWFirst( byte alarm_only )
{
   // reset the search state
   DS2480LastDiscrepancy = 0;
   DS2480LastDevice = FALSE;
   DS2480LastFamilyDiscrepancy = 0;

	return( DS2480_OWSearch ( alarm_only ) );
}


//----------------------------------------------------------------------//
byte DS2480_OWNext( byte alarm_only )
{
	return( DS2480_OWSearch ( alarm_only ) );
}


//----------------------------------------------------------------------//
void DS2480_cmd( byte cmd )
{
	if ( DS2480_Mode != DS2480_CMD )
		{
		DS2480_Mode = DS2480_CMD;
		DS2480_Put( 0xE3 );
		}


	if ( cmd & 0x80 )				// jeli COMMUNICATION COMMAND CODES Table 1 (str.6)
		{
		if ( (cmd & 0xE0) != 0xE0 )	// i nie program pulse
			{
			cmd &= 0b11110011;		// Czycimy bity prdkoci
			// Jeli linia duga to nie przechodzimy na onewireOverdrive
			if ( !onewireFlexible ) if ( onewireOverdrive ) cmd |= 0b1000;
			if ( onewireFlexible ) cmd |= 0b0100;
}
#warning "USER: W obsudze DS18B20 i DS2431 zastpi spilny pullup wywolanem funkcji pulse"
/*
		if ( !(cmd & 0b01100000) )		// Jeli operacja bitowa
			{
			// Silny pullup spowoduje, e pojawi si impuls 524ms
			if ( onewireStrong ) cmd |= 0x2;
			}
*/
		}
	else							// CONFIGURATION COMMAND CODES Table 5 (str.11)
		{							// CONFIGURATION PARAMETER VALUE CODES Table 4 (str.10)
		// 0cccvvv1		// ccc-parameter code, vvv-value code

		}


	DS2480_Put( cmd );
}


//----------------------------------------------------------------------//
word DS2480_OW_WRbit( byte bit )
{
	if ( bit ) DS2480_cmd( 0x91 ); else DS2480_cmd( 0x81 );


	return( DS2480_Get() );
}


//----------------------------------------------------------------------//
word DS2480_OW_RDbit()
{
word bit;
byte pull;


	pull = onewireStrong;		// Zapamitaj silne podciganie
	onewireStrong = false;		// Wycz je
	DS2480_cmd( 0x91 );			//Bez silnego podcigania magistrali bo robimy odczyt
	onewireStrong = pull;		// Przywr


	if ( (bit=DS2480_Get()) != NONE ) return( bit & 0x20 );


	return( NONE );
}


//----------------------------------------------------------------------//
word DS2480_OW_WRbyte( byte dana )
{
word timeout= 10 * DS2480_WAIT_BYTE_MS;


	DS2480_OW_LastByte = dana;


	if ( DS2480_Mode != DS2480_DATA )
		{
		DS2480_Mode = DS2480_DATA;
		DS2480_Put( 0xE1 );
		}


	DS2480_Put( dana );
	return( DS2480_Get() );
}


//----------------------------------------------------------------------//
word DS2480_OW_RDbyte()
{
word bajt;


	if ( DS2480_Mode != DS2480_DATA )
		{
		DS2480_Put( 0xE1 );
		DS2480_Mode = DS2480_DATA;
		}


	DS2480_Put( 0xFF );
	return( DS2480_Get() );
}


//----------------------------------------------------------------------//
byte DS2480_Init()
{
byte blok[5];


	DS2480_break();

	DS2480_Put( 0xC1 );		// Seset w standardowej prdkoci
	_delay_ms( 2 );
	UsartDS_Flush();


	//	   PDSRC		  W1LD			 WORT			RBR			   1Wbit
	UsartDS_Flush();
/*
	DS2480_Put( 0x17 ); DS2480_Put( 0x45 ); DS2480_Put( 0x5B ); DS2480_Put( 0x0F ); DS2480_Put( 0x91 );
	if ( DS2480_GetBlockDS( blok, 5, 10 )==5 )
		{
		if ( blok[0] != 0x16 ) return( false );
		if ( blok[1] != 0x44 ) return( false );
		if ( blok[2] != 0x5A ) return( false );
		if ( blok[3] != 0x00 ) return( false );
//		if ( blok[4] != 0x93 ) return( false );	// Warto odczytanego bitu z magistrali 91-1, 81-0
		}
*/
	DS2480_Put( 0x17 ); if (DS2480_Get() != 0x16 ) return( false );	// PDSRC
	DS2480_Put( 0x45 ); if (DS2480_Get() != 0x44 ) return( false );	// W1LD
	DS2480_Put( 0x5B ); if (DS2480_Get() != 0x5A ) return( false );	// WORT
	DS2480_Put( 0x0F ); if (DS2480_Get() != 0x00 ) return( false );	// RBR
//	DS2480_Put( 0x91 ); if (DS2480_Get() != 0x93 ) return( false );	// 1Wbit


	DS2480_Version();


	DS2480_RBR( DS2480_115200 );	// Zmiana prdkoci na 115200 str.7 AN192


	return( true );
}


//----------------------------------------------------------------------//
#define UBRR_VALUE_DSFAST (((F_CPU) + 8UL * (BAUD_DSFAST)) / (16UL * (BAUD_DSFAST)) -1UL)

#if 100 * (F_CPU) > (16 * ((UBRR_VALUE_DSFAST) + 1)) * (100 * (BAUD_DSFAST) + (BAUD_DSFAST) * (BAUD_TOL))
 #define USE_2X_DSFAST		1
#elif 100 * (F_CPU) < (16 * ((UBRR_VALUE_DSFAST) + 1)) * (100 * (BAUD_DSFAST) - (BAUD_DSFAST) * (BAUD_TOL))
 #define USE_2X_DSFAST		1
#else
 #define USE_2X_DSFAST		0
#endif

#if USE_2X_DSFAST
/* U2X required, recalculate */
#undef UBRR_VALUE_DSFAST

#ifdef __ASSEMBLER__
#define UBRR_VALUE_DSFAST (((F_CPU) + 4 * (BAUD_DSFAST)) / (8 * (BAUD_DSFAST)) -1)
#else
#define UBRR_VALUE_DSFAST (((F_CPU) + 4UL * (BAUD_DSFAST)) / (8UL * (BAUD_DSFAST)) -1UL)
#endif

#if 100 * (F_CPU) > \
  (8 * ((UBRR_VALUE_DSFAST) + 1)) * (100 * (BAUD_DSFAST) + (BAUD_DSFAST) * (BAUD_TOL))
#warning "Baud rate achieved is higher than allowed"
#endif

#endif /* USE_U2X */

#if 100 * (F_CPU) < \
  (8 * ((UBRR_VALUE_DSFAST) + 1)) * (100 * (BAUD_DSFAST) - (BAUD_DSFAST) * (BAUD_TOL))
#warning "Baud rate achieved is lower than allowed"
#endif

#ifdef UBRR_VALUE_DSFAST
/* Check for overflow */
 #if UBRR_VALUE_DSFAST >= (1 << 12)
  #error "UBRR value overflow"
 #endif

#define UBRRL_VALUE_DSFAST (UBRR_VALUE_DSFAST & 0xff)
#define UBRRH_VALUE_DSFAST (UBRR_VALUE_DSFAST >> 8)
#endif


//----------------------------------------------------------------------//
//todo: Zmiana prdkoci na 115200 str.7 AN192
// Aby wrci do standardowej najlepiej zrobic init (BREAK)
//
byte DS2480_RBR( byte predkosc )
{
word rbr;


//	if ( onewireFlexible ) return( -2 );	// Jeli linia duga to dziaamy zawsze na 9600


	predkosc &= 0b00001110;
	predkosc |= 0b01110001;
	DS2480_cmd( predkosc );		// Zmiana prdkoci na 115200 str.7 AN192

	_delay_ms( 5 );
	#if USE_2X_DSFAST
	  USARTDS_UCSRA |= _BV(U2X0);
//#error "zle ustawia predkosc prawdopodobnie RBR bo X2 wyglada ok"
	#endif
	USARTDS_UBRRL = UBRRL_VALUE_DSFAST;
	USARTDS_UBRRH = UBRRH_VALUE_DSFAST;

	UsartDS_Flush();
	DS2480_cmd( 0x0F );			// Odczyt prdkoci
	if ( (rbr=DS2480_Get()) != NONE )
		{
		DS2480_rbr = rbr & 0b1110;
		return( DS2480_rbr );
		// 0b000x 9600
		// 0b001x 19200
		// 0b010x 57600
		// 0b011x 115200
		}
	return( NONE );
}


//----------------------------------------------------------------------//
byte DS2480_Version()
{
word ver;


	DS2480_cmd( 0b11000101 );
	if ( (ver=DS2480_Get()) != NONE )
		{
		DS2480_ver = ver & 0b11100;
		return( DS2480_ver );
		// 010xx DS2480
		// 011xx DS2480B
		// 100xx (future)
		}
	return( NONE );
}


//----------------------------------------------------------------------//
byte DS2480_OW_Reset()
{
word res;


	UsartDS_Flush();
	DS2480_cmd( 0xC1 );
	if ( (res=DS2480_Get()) != NONE )
		{
		// 0b00 1-Wire shorted
		// 0b01 presence
		// 0b10 alarm presence
		// 0b11 no presence
		// 0x1xxxx - Vpp
		DS2480_rst = res &= 3;
		if ( DS2480_rst==1 || DS2480_rst==2 ) return( true );
		}
	return( false );
}


//----------------------------------------------------------------------//
// Aby test sie powidl, VPP musi by obecne na wyprowadzeniu DS2480
// np przetwornica wczona
//----------------------------------------------------------------------//
byte DS2480_TestVpp()
{
byte ovd;
word vpp;


	UsartDS_Flush();

	//----- Reset w overdrive -----//
	ovd = onewireOverdrive;
	onewireOverdrive = true;
	DS2480_cmd( 0xC1 );
	onewireOverdrive = ovd;

	if ( (vpp=DS2480_Get()) != NONE )
		{
		// 0b00 1-Wire shorted
		// 0b01 presence
		// 0b10 alarm presence
		// 0b11 no presence
		// 0x1xxxx - Vpp
		#warning "USER: &= odkomentowa"
		DS2480_vpp = vpp ;//&= 0x10;
		}
	return( vpp & 0x10 );
}


//----------------------------------------------------------------------//
void DS2480_PGMpulse( byte vpp )
{
//todo: do zrobienia
	if ( vpp ==5 )
		{
//
// ED i EF nie daja odpowiedzi
		}
	else if ( vpp==12)
		{
		DS2480_cmd( 0xFD ); // Prog pulse
		DS2480_Get();
	}
}


//----------------------------------------------------------------------//
byte DS2480_OWSearch( byte alarm_only )
{
byte i,tmp_last_desc,pos;
uchar tmp_serial_num[8];
uchar readbuffer[20],sendpacket[40];
byte sendlen=0;
uchar lastcrc8;	//todo: static-test
byte readLen;


   // if the last call was the last one
   if (DS2480LastDevice)
   {
      // reset the search
      DS2480LastDiscrepancy = 0;
      DS2480LastDevice = FALSE;
      DS2480LastFamilyDiscrepancy = 0;
      return FALSE;
   }

   // check if reset first is requested
   if (true)
   {
      // reset the 1-wire
      // if there are no parts on 1-wire, return FALSE
      if ( !DS2480_OW_Reset() )
      {
         // reset the search
         DS2480LastDiscrepancy = 0;
         DS2480LastFamilyDiscrepancy = 0;
         return FALSE;
      }
   }
	UMode = MODSEL_COMMAND;		// Po resecie domylnie tryb komend

   // build the command stream
   // call a function that may add the change mode command to the buff
   // check if correct mode
   if (UMode != MODSEL_DATA)
   {
      UMode = MODSEL_DATA; sendpacket[sendlen++] = 0xE1;
   }

   // search command
   if (alarm_only)
      sendpacket[sendlen++] = 0xEC; // issue the alarming search command
   else
      sendpacket[sendlen++] = 0xF0; // issue the search command

   // change back to command mode
   UMode = MODSEL_COMMAND; sendpacket[sendlen++] = 0xE3;

   // search mode on
   sendpacket[sendlen++] = ( 0b10110101 );		// search acceleration ON


   // change back to data mode
   UMode = MODSEL_DATA;  sendpacket[sendlen++] = 0xE1;

   // set the temp Last Descrep to none
   tmp_last_desc = 0xFF;

   // add the 16 bytes of the search
   pos = sendlen;
   for (i = 0; i < 16; i++)
      sendpacket[sendlen++] = 0;

   // only modify bits if not the first search
   if (DS2480LastDiscrepancy != 0xFF)
   {
      // set the bits in the added buffer
      for (i = 0; i < 64; i++)
      {
         // before last discrepancy
         if (i < (DS2480LastDiscrepancy - 1))
               bitacc(WRITE_FUNCTION,
                   bitacc(READ_FUNCTION,0,i,&OW_SEARCH_ROM_NO[0]),
                   (short)(i * 2 + 1),
                   &sendpacket[pos]);
         // at last discrepancy
         else if (i == (DS2480LastDiscrepancy - 1))
                bitacc(WRITE_FUNCTION,1,
                   (short)(i * 2 + 1),
                   &sendpacket[pos]);
         // after last discrepancy so leave zeros
      }
   }

   // change back to command mode
   UMode = MODSEL_COMMAND; sendpacket[sendlen++] = 0xE3;

   // search OFF
   sendpacket[sendlen++] = ( 0b10100101 );		// search acceleration OFF

   // flush the buffers
 	UsartDS_Flush();

   // send the packet
//	for(byte x=0; x<sendlen; x++) DS2480_Put( *(sendpacket+x) );
byte y=0;
	for(byte x=0; x<sendlen; x++)
		{
		DS2480_Put( *(sendpacket+x) );
		if ( x==1 || x>=5 ) readbuffer[y++] = DS2480_Get();	// Mona przyj stae wartoci 1 i 5 bo UsartDS_Flush() a "UMode" zawsze takie samo
		} readLen = 17;
if ( true /*WriteCOM(sendlen,sendpacket)*/ )
   {
      // read back the 1 byte response
//      if ( true /*ReadCOM(17,readbuffer) == 17*/ )
//	readLen = DS2480_GetBlockDS( readbuffer, 30, 17 );
	if ( readLen == 17 )
      {
         // interpret the bit stream
         for (i = 0; i < 64; i++)
         {
            // get the SerialNum bit
            bitacc(WRITE_FUNCTION,
                   bitacc(READ_FUNCTION,0,(short)(i * 2 + 1),&readbuffer[1]),
                   i,
                   &tmp_serial_num[0]);
            // check LastDiscrepancy
            if ((bitacc(READ_FUNCTION,0,(short)(i * 2),&readbuffer[1]) == 1) &&
                (bitacc(READ_FUNCTION,0,(short)(i * 2 + 1),&readbuffer[1]) == 0))
            {
               tmp_last_desc = i + 1;
               // check LastFamilyDiscrepancy
               if (i < 8)
                  DS2480LastFamilyDiscrepancy = i + 1;
            }
         }

         // do dowcrc
         lastcrc8 = 0;
         for (i = 0; i < 8; i++) _crc_ibutton_update( lastcrc8, tmp_serial_num[i]);

         // check results
         if ( (lastcrc8 != 0) || (DS2480LastDiscrepancy == 63) || (tmp_serial_num[0] == 0))
         {
            // error during search
            // reset the search
            DS2480LastDiscrepancy = 0;
            DS2480LastDevice = FALSE;
            DS2480LastFamilyDiscrepancy = 0;
            return FALSE;
         }
         // successful search
         else
         {
            // check for lastone
            if ((tmp_last_desc == DS2480LastDiscrepancy) || (tmp_last_desc == 0xFF))
               DS2480LastDevice = TRUE;

            // copy the SerialNum to the buffer
            for (i = 0; i < 8; i++) OW_SEARCH_ROM_NO[i] = tmp_serial_num[i];

            // set the count
            DS2480LastDiscrepancy = tmp_last_desc;
            return TRUE;
         }
      }
   }

   // an error occured so re-sync with DS2480
//   DS2480Detect();

   // reset the search
   DS2480LastDiscrepancy = 0;
   DS2480LastDevice = FALSE;
   DS2480LastFamilyDiscrepancy = 0;

   return FALSE;
}


//--------------------------------------------------------------------------
// Bit utility to read and write a bit in the buffer 'buf'.
//
// 'op'    - operation (1) to set and (0) to read
// 'state' - set (1) or clear (0) if operation is write (1)
// 'loc'   - bit number location to read or write
// 'buf'   - pointer to array of bytes that contains the bit
//           to read or write
//
// Returns: 1   if operation is set (1)
//          0/1 state of bit number 'loc' if operation is reading
//
byte bitacc( byte op, byte state, byte loc, byte *buf )
{
   int nbyt,nbit;

   nbyt = (loc / 8);
   nbit = loc - (nbyt * 8);

   if (op == WRITE_FUNCTION)
   {
      if (state)
         buf[nbyt] |= (0x01 << nbit);
      else
         buf[nbyt] &= ~(0x01 << nbit);

      return 1;
   }
   else
      return ((buf[nbyt] >> nbit) & 0x01);
}


//======================================================================//



