/*
Generatory uywane w praktyce posiadaj nastpujce wartoci wspczynnikw:
Nazwa							m			a				c
Numerical Recipes				2^32		1664525			1013904223
Borland C/C++					2^32		22695477		1
GNU Compiler Collection			2^32		69069			5
ANSI C							2^32		1103515245		12345
Borland Delphi, Virtual Pascal	2^32		134775813		1
Microsoft Visual/Quick C/C++	2^32		214013			2531011
ANSIC							2^31		1103515245		12345
MINSTD							2^31-1		16807			0
RANDU							2^31		65539			0
SIMSCRIPT						2^31-1		630360016		0
BCSLIB							2^35		30517578125		7261067085
BCPL							2^32		2147001325		715136305
URN12							2^31		452807053		0
APPLE							2^35		1220703125		0
Super-Duper						2^32		69069			0
FISH							2^31-1		950706376		0
SIMULA							2^35		30517578125		0
NAG								2^59		302875106592253	0
DRAND 48						2^48		25214903917		11
CRAY							2^48		44485709377909	0
MAPLE							10^12-11	427619669081	0
DERIVE							2^32		3141592653		1
CRAND							2^32		663608941		0


Generowanie liczb pseudolosowych z zakresu <a, b>:
Jeeli chcemy wygenerowa cig liczb pseudolosowych z zadanego zakresu,
nie powinnimy modyfikowa wspczynnika m w przytoczonych przykadach.
Parametry przedstawione w nich s tak dobrane by osign jak najduszy cykl generowanych
liczb pseudolosowych. Naley zatem losowane liczby sprowadzi do interesujcego nas przedziau.
Mona to zrobi nastpujco (przez rand() oznaczymy przedstawiony wczeniej generator
liczb pseudolosowych): a + (rand() mod (b-a+1)).
*/


//generowanie liczb pseudolosowych
//generator LCG
//www.algorytm.org (c) 2008 Tomasz Lubinski

#include "stdio.h"

unsigned long long rnd_m=32;
unsigned long long rnd_a=1103515245;
unsigned long long rnd_c=12345;
unsigned long long rnd_x;		// Ziarno

// Calculate a*x mod m
unsigned long long mult(unsigned long long a, unsigned long long  x, unsigned long long m)
{
unsigned long long b,n,r;

   r = 0;
   n = 1;
   b = 1;
   while (n <= 64)
   {
      if ((a & b) != 0)
         r = (r + x) % m;
      rnd_x = (rnd_x + rnd_x) % m;
      b *= 2;
      n++;
   }

   return r;
}


void setRand( long long z )
{
	rnd_x = z;
}


unsigned long long genRand()
{
   rnd_x = (mult(rnd_a, rnd_x, rnd_m) + rnd_c) % rnd_m;
   return rnd_x;
}

/*
int main()
{
   int i, n;
   unsigned long long low, high;

   printf("Podaj wspolczynnik m\n");
   scanf("%Ld", &m);

   printf("Podaj wspolczynnik a\n");
   scanf("%Ld", &a);

   printf("Podaj wspolczynnik c\n");
   scanf("%Ld", &c);

   printf("Podaj wartosc ziarna x[1]\n");
   scanf("%Ld", &x);

   printf("Podaj ile liczb pseudolosowych wylosowac\n");
   scanf("%d", &n);

   printf("Podaj dolna wartosc zakresu generowanych liczb\n");
   scanf("%Ld", &low);

   printf("Podaj gorna wartosc zakresu generowanych liczb\n");
   scanf("%Ld", &high);

   for (i=0; i<n; i++)
   {
      printf("%Ld\n", low + (genRand() % (high - low + 1)));
   }

   return 0;
}
*/


